/* -*-C++-*- */
/*
 *  Copyright (c) 1999 Regents of the University of California.
 *  All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions
 *  are met:
 *  1. Redistributions of source code must retain the above copyright
 *     notice, this list of conditions and the following disclaimer.
 *  2. Redistributions in binary form must reproduce the above copyright
 *     notice, this list of conditions and the following disclaimer in the
 *     documentation and/or other materials provided with the distribution.
 *  3. All advertising materials mentioning features or use of this software
 *     must display the following acknowledgment:
 *       This product includes software developed by the Imaging and
 *       Distributed Collaboratories Group at Lawrence Berkeley
 *       National Laboratory.
 *  4. Neither the name of the University nor of the Laboratory may be used
 *     to endorse or promote products derived from this software without
 *     specific prior written permission.
 *
 *  THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 *  ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 *  IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 *  ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 *  FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 *  DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 *  OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 *  HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 *  LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 *  OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 *  SUCH DAMAGE.
 *
 */

#ifndef MyDebug_h
#define MyDebug_h

#include <stdarg.h>
#include <string>
static int mDebugLevel(0);

class MyDebug
{
  public:
    MyDebug( const std::string name = "LBLNetTest: " );
    virtual ~MyDebug();
  //protected:
    inline int setDebugLevel( int level)
    {
	mDebugLevel = level;
	return mDebugLevel;
    };
    inline int  getDebugLevel( void )
    {
	return mDebugLevel;
    };
    inline void setClassName( const std::string name )
    {
	mClassname = name;
    };
    inline void setPrintAll( int val )
    {
	mPrintall = val;
    };
    void printDebug( int level, const char *str1, ... );\
    void printDebug( int level, const std::string msg);
    void printExactDebug( int level, const char *str1, ... );
    void printExactDebug( int level, const std::string msg);
    void printError( const char *str1, ... );
    void printError (const std::string msg);
  private:
    //int mDebugLevel;
    //extern int mDebugLevel;
    int mPrintall;
    std::string mClassname;
};

#endif // MyDebug_h
