/* -*-C++-*- */
/* Copyright (c) 1999 Regents of the University of California.
 * rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgment:
 *       This product includes software developed by the Imaging and
 *       Distributed Collaboratories Group at Lawrence Berkeley
 *       National Laboratory.
 * 4. Neither the name of the University nor of the Laboratory may be used
 *    to endorse or promote products derived from this software without
 *    specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
*/

#ifndef NETWORKTCP_H
#define NETWORKTCP_H

#include "securetcp.h"
#include "tcpnet.h"
#include "SecurityInfo.h"
#include <string>

using std::string;

class NetworkTCP
{

  private:
    TCPNet       *sockAccept;
    SecurityInfo secInfo;
    string 	 client_Key;
    string 	 client_Cert;
    string 	 server_Key;
    string 	 server_Cert;

  public:
    NetworkTCP();
    ~NetworkTCP();

    int testCallBackFunction( bool isServer, CallBackPtr pass_cb );

    SecureTcp*  newTCP_accept( CallBackPtr pass_cb=NULL );
    SecureTcp*  newTCP_connect( string hostname, CallBackPtr pass_cb=NULL );

    inline void setClientKeyfilename( string key ){
	client_Key = key;
    };
    inline void setClientCertfilename( string cert ){
	client_Cert = cert;
    };
    inline void setServerKeyfilename( string key ){
	client_Key = key;
    };
    inline void setServerCertfilename( string cert ){
	client_Cert = cert;
    };
};
#endif
